#
#  atheme buildsys.mk
#  Copyright (c) 2012 William Pitcock <nenolod@dereferenced.org>
# 
#  Copyright (c) 2007, 2008, 2009, 2010, 2011, 2012
#  Jonathan Schleifer <js@webkeks.org>
#
#  Based on buildsys.mk:
#  https://webkeks.org/git/?p=buildsys.git
#
#  Permission to use, copy, modify, and/or distribute this software for any
#  purpose with or without fee is hereby granted, provided that the above
#  copyright notice and this permission notice is present in all copies.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
#  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
#  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
#  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
#  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
#  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
#  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
#  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
#  POSSIBILITY OF SUCH DAMAGE.
#

#V=1
PACKAGE_NAME = atheme
PACKAGE_VERSION = 7.1.0-alpha1
AS = @AS@
CC = gcc -std=gnu99
CXX = @CXX@
CPP = gcc -std=gnu99 -E
DC = @DC@
ERLC = @ERLC@
OBJC = @OBJC@
OBJCXX = @OBJCXX@
AR = /usr/bin/ar
LD = ${CC}
RANLIB = /usr/bin/ranlib
PYTHON = @PYTHON@
ASFLAGS = @ASFLAGS@
CFLAGS = -g -O2
CXXFLAGS = @CXXFLAGS@
CPPFLAGS = -g -O2  -std=gnu99 -Werror-implicit-function-declaration  -DPREFIX=\"${prefix}\" -DLOCALEDIR=\"${LOCALEDIR}\" -DMODDIR=\"${MODDIR}\" -DSHAREDIR=\"${prefix}\" -DSYSCONFDIR=\"${prefix}/etc\" -DLOGDIR=\"${prefix}/var\" -DRUNDIR=\"${prefix}/var\" -DDATADIR=\"${prefix}/etc\" -I/usr/include/libmowgli-2  
DFLAGS = @DFLAGS@
ERLCFLAGS = @ERLCFLAGS@
OBJCFLAGS = @OBJCFLAGS@
OBJCXXFLAGS = @OBJCXXFLAGS@
LDFLAGS = 
LDFLAGS_RPATH = -Wl,-rpath,${libdir}
LIBS = -lcrypt    -lmowgli-2  
PYTHON_FLAGS = @PYTHON_FLAGS@
PROG_IMPLIB_NEEDED = no
PROG_IMPLIB_LDFLAGS = 
PROG_SUFFIX = 
LIB_CFLAGS = -fPIC -DPIC
LIB_LDFLAGS = -shared -Wl,-soname=${SHARED_LIB}.${LIB_MAJOR}
LIB_PREFIX = lib
LIB_SUFFIX = .so
PLUGIN_CFLAGS = -fPIC -DPIC
PLUGIN_LDFLAGS = -shared
PLUGIN_SUFFIX = .so
INSTALL_LIB = && ${INSTALL} -m 755 $$i ${DESTDIR}${libdir}/$$i.${LIB_MAJOR}.${LIB_MINOR}.0 && ${LN_S} -f $$i.${LIB_MAJOR}.${LIB_MINOR}.0 ${DESTDIR}${libdir}/$$i.${LIB_MAJOR} && ${LN_S} -f $$i.${LIB_MAJOR}.${LIB_MINOR}.0 ${DESTDIR}${libdir}/$$i
UNINSTALL_LIB = && rm -f ${DESTDIR}${libdir}/$$i ${DESTDIR}${libdir}/$$i.${LIB_MAJOR} ${DESTDIR}${libdir}/$$i.${LIB_MAJOR}.${LIB_MINOR}.0
CLEAN_LIB = 
LN_S = ln -s
MKDIR_P = mkdir -p
INSTALL = /usr/bin/install -c
SHELL = /bin/bash
MSGFMT = :
JAVAC = @JAVAC@
JAVACFLAGS = @JAVACFLAGS@
JAR = @JAR@
WINDRES = @WINDRES@
prefix = /home/xena/prefix/atheme
exec_prefix = ${prefix}
bindir = ${exec_prefix}/bin
libdir = ${exec_prefix}/lib
plugindir ?= ${libdir}/${PACKAGE_NAME}
datarootdir = ${prefix}/share
datadir = ${datarootdir}
includedir = ${prefix}/include
includesubdir ?= ${PACKAGE_NAME}
localedir = ${datarootdir}/locale
localename ?= ${PACKAGE_NAME}
mandir = ${datarootdir}/man
mansubdir ?= man1

OBJS1 = ${SRCS:.c=.o}
OBJS2 = ${OBJS1:.cc=.o}
OBJS3 = ${OBJS2:.cxx=.o}
OBJS4 = ${OBJS3:.d=.o}
OBJS5 = ${OBJS4:.erl=.beam}
OBJS6 = ${OBJS5:.java=.class}
OBJS7 = ${OBJS6:.m=.o}
OBJS8 = ${OBJS7:.mm=.o}
OBJS9 = ${OBJS8:.py=.pyc}
OBJS10 = ${OBJS9:.rc=.o}
OBJS11 = ${OBJS10:.S=.o}
OBJS += ${OBJS11:.xpm=.o}

LIB_OBJS = ${OBJS:.o=.lib.o}
PLUGIN_OBJS = ${OBJS:.o=.plugin.o}

MO_FILES = ${LOCALES:.po=.mo}
DEPFLAGS = -MMD -MP

.SILENT:
.SUFFIXES:
.SUFFIXES: .beam .c .cc .class .cxx .d .erl .lib.o .java .mo .m .mm .mm.d .o .plugin.o .po .py .pyc .rc .S .xpm
.PHONY: all subdirs ${SUBDIRS} pre-depend depend install install-extra uninstall uninstall-extra clean distclean locales

all: subdirs depend ${STATIC_LIB} ${STATIC_LIB_NOINST} ${STATIC_PIC_LIB} ${STATIC_PIC_LIB_NOINST} ${SHARED_LIB} ${SHARED_LIB_NOINST} ${PLUGIN} ${PLUGIN_NOINST} ${PROG} ${PROG_NOINST} ${JARFILE} locales

pre-recurse: 
subdirs: pre-recurse ${SUBDIRS}
${SUBDIRS}:
	${MAKE} -C $@ ${MFLAGS}

depend: pre-depend
pre-depend:

echo-cmd = $(if $($(QUIET)$(1)),$(info $(phase_$(1)): $($(QUIET)$(1))))

${PROG} ${PROG_NOINST}: ${EXT_DEPS} ${OBJS} ${OBJS_EXTRA}
	LDOBJS="${OBJS} ${OBJS_EXTRA}"; \
	${LINK_STATUS}; \
	if ${LD} -o $@ ${OBJS} ${OBJS_EXTRA} ${LDFLAGS} ${LIBS}; then \
		${LINK_OK}; \
	else \
		${LINK_FAILED}; \
	fi

${JARFILE}: ${EXT_DEPS} ${JAR_MANIFEST} ${OBJS} ${OBJS_EXTRA}
	${LINK_STATUS}
	if test x"${JAR_MANIFEST}" != x""; then \
		if ${JAR} cfm ${JARFILE} ${JAR_MANIFEST} ${OBJS} ${OBJS_EXTRA}; then \
			${LINK_OK}; \
		else \
			${LINK_FAILED}; \
		fi \
	else \
		if ${JAR} cf ${JARFILE} ${OBJS} ${OBJS_EXTRA}; then \
			${LINK_OK}; \
		else \
			${LINK_FAILED}; \
		fi \
	fi

${SHARED_LIB} ${SHARED_LIB_NOINST}: ${EXT_DEPS} ${LIB_OBJS} ${LIB_OBJS_EXTRA}
	LDOBJS="${LIB_OBJS} ${LIB_OBJS_EXTRA}"; \
	${LINK_STATUS}; \
	objs=""; \
	ars=""; \
	for i in ${LIB_OBJS} ${LIB_OBJS_EXTRA}; do \
		case $$i in \
			*.a) \
				ars="$$ars $$i" \
				;; \
			*.o) \
				objs="$$objs $$i" \
				;; \
		esac \
	done; \
	for i in $$ars; do \
		dir=".$$(echo $$i | sed 's/\//_/g').objs"; \
		rm -fr $$dir; \
		mkdir -p $$dir; \
		cd $$dir; \
		${AR} x ../$$i; \
		for j in *.o; do \
			objs="$$objs $$dir/$$j"; \
		done; \
		cd ..; \
	done; \
	if ${LD} -o $@ $$objs ${LIB_LDFLAGS} ${LDFLAGS} ${LIBS}; then \
		${LINK_OK}; \
	else \
		${LINK_FAILED}; \
	fi; \
	for i in $$ars; do \
		dir=".$$(echo $$i | sed 's/\//_/g').objs"; \
		rm -fr $$dir; \
	done

${PLUGIN} ${PLUGIN_NOINST}: ${EXT_DEPS} ${PLUGIN_OBJS}
	LDOBJS="${PLUGIN_OBJS}"; \
	${LINK_STATUS}; \
	objs=""; \
	ars=""; \
	for i in ${PLUGIN_OBJS}; do \
		case $$i in \
			*.a) \
				ars="$$ars $$i" \
				;; \
			*.o) \
				objs="$$objs $$i" \
				;; \
		esac \
	done; \
	for i in $$ars; do \
		dir=".$$(echo $$i | sed 's/\//_/g').objs"; \
		rm -fr $$dir; \
		mkdir -p $$dir; \
		cd $$dir; \
		${AR} x ../$$i; \
		for j in *.o; do \
			objs="$$objs $$dir/$$j"; \
		done; \
		cd ..; \
	done; \
	if ${LD} -o $@ $$objs ${PLUGIN_LDFLAGS} ${LDFLAGS} ${LIBS}; then \
		${LINK_OK}; \
	else \
		${LINK_FAILED}; \
	fi; \
	for i in $$ars; do \
		dir=".$$(echo $$i | sed 's/\//_/g').objs"; \
		rm -fr $$dir; \
	done

${STATIC_LIB} ${STATIC_LIB_NOINST}: ${EXT_DEPS} ${OBJS} ${OBJS_EXTRA}
	LDOBJS="${OBJS} ${OBJS_EXTRA}"; \
	${LINK_STATUS}; \
	rm -f $@; \
	objs=""; \
	ars=""; \
	for i in ${OBJS} ${OBJS_EXTRA}; do \
		case $$i in \
			*.a) \
				ars="$$ars $$i" \
				;; \
			*.o) \
				objs="$$objs $$i" \
				;; \
		esac \
	done; \
	for i in $$ars; do \
		dir=".$$(echo $$i | sed 's/\//_/g').objs"; \
		rm -fr $$dir; \
		mkdir -p $$dir; \
		cd $$dir; \
		${AR} x ../$$i; \
		for j in *.o; do \
			objs="$$objs $$dir/$$j"; \
		done; \
		cd ..; \
	done; \
	if ${AR} cr $@ $$objs && ${RANLIB} $@; then \
		${LINK_OK}; \
	else \
		${LINK_FAILED}; \
		rm -f $@; \
	fi; \
	for i in $$ars; do \
		dir=".$$(echo $$i | sed 's/\//_/g').objs"; \
		rm -fr $$dir; \
	done

${STATIC_PIC_LIB} ${STATIC_PIC_LIB_NOINST}: ${EXT_DEPS} ${LIB_OBJS} ${LIB_OBJS_EXTRA}
	LDOBJS="${LIB_OBJS} ${LIB_OBJS_EXTRA}"; \
	${LINK_STATUS}; \
	rm -f $@
	objs=""; \
	ars=""; \
	for i in ${LIB_OBJS} ${LIB_OBJS_EXTRA}; do \
		case $$i in \
			*.a) \
				ars="$$ars $$i" \
				;; \
			*.o) \
				objs="$$objs $$i" \
				;; \
		esac \
	done; \
	for i in $$ars; do \
		dir=".$$(echo $$i | sed 's/\//_/g').objs"; \
		rm -fr $$dir; \
		mkdir -p $$dir; \
		cd $$dir; \
		${AR} x ../$$i; \
		for j in *.o; do \
			objs="$$objs $$dir/$$j"; \
		done; \
		cd ..; \
	done; \
	if ${AR} cr $@ $$objs && ${RANLIB} $@; then \
		${LINK_OK}; \
	else \
		${LINK_FAILED}; \
		rm -f $@; \
	fi; \
	for i in $$ars; do \
		dir=".$$(echo $$i | sed 's/\//_/g').objs"; \
		rm -fr $$dir; \
	done

locales: ${MO_FILES}

phase_cmd_cc = CompileExe
quiet_cmd_cc = $@
      cmd_cc = ${CC} ${DEPFLAGS} ${CFLAGS} ${CPPFLAGS} -c -o $@ $<

phase_cmd_cc_lib = CompileLib
quiet_cmd_cc_lib = $@
      cmd_cc_lib = ${CC} ${DEPFLAGS} ${LIB_CFLAGS} ${CFLAGS} ${CPPFLAGS} -c -o $@ $<

phase_cmd_cc_plugin = CompilePlugin
quiet_cmd_cc_plugin = $@
      cmd_cc_plugin = ${CC} ${DEPFLAGS} ${PLUGIN_CFLAGS} ${CFLAGS} ${CPPFLAGS} -c -o $@ $<

.c.o:
	$(call echo-cmd,cmd_cc)
	$(cmd_cc)

.c.lib.o:
	$(call echo-cmd,cmd_cc_lib)
	$(cmd_cc_lib)

.c.plugin.o:
	$(call echo-cmd,cmd_cc_plugin)
	$(cmd_cc_plugin)

phase_cmd_cxx = CompileExe
quiet_cmd_cxx = $@
      cmd_cxx = ${CXX} ${DEPFLAGS} ${CXXFLAGS} ${CPPFLAGS} -c -o $@ $<

phase_cmd_cxx_lib = CompileLib
quiet_cmd_cxx_lib = $@
      cmd_cxx_lib = ${CXX} ${DEPFLAGS} ${LIB_CFLAGS} ${CXXFLAGS} ${CPPFLAGS} -c -o $@ $<

phase_cmd_cxx_plugin = CompilePlugin
quiet_cmd_cxx_plugin = $@
      cmd_cxx_plugin = ${CXX} ${DEPFLAGS} ${PLUGIN_CFLAGS} ${CXXFLAGS} ${CPPFLAGS} -c -o $@ $<

.cc.o .cxx.o:
	$(call echo-cmd,cmd_cxx)
	$(cmd_cxx)

.cc.lib.o .cxx.lib.o:
	$(call echo-cmd,cmd_cxx_lib)
	$(cmd_cxx_lib)

.cc.plugin.o .cxx.plugin.o:
	$(call echo-cmd,cmd_cxx_plugin)
	$(cmd_cxx_plugin)

phase_cmd_dc = CompileExe
quiet_cmd_dc = $@

ifeq ($(basename ${DC}),dmd)
      cmd_dc = ${CXX} ${CXXFLAGS} ${CPPFLAGS} -c -of$@ $<
else
      cmd_dc = ${CXX} ${CXXFLAGS} ${CPPFLAGS} -c -o $@ $<
endif

.d.o:
	$(call echo-cmd,cmd_dc)
	$(cmd_dc)

phase_cmd_erlc = CompileErlang
quiet_cmd_erlc = $@
      cmd_erlc = ${ERLC} ${ERLCFLAGS} -o $@ $<

.erl.beam:
	$(call echo-cmd,cmd_erlc)
	$(cmd_erlc)

phase_cmd_javac = CompileJava
quiet_cmd_javac = $@
      cmd_javac = ${JAVAC} ${JAVACFLAGS} $<

.java.class:
	$(call echo-cmd,cmd_javac)
	$(cmd_javac)

phase_cmd_objc = CompileExe
quiet_cmd_objc = $@
      cmd_objc = ${OBJC} ${OBJCFLAGS} ${CPPFLAGS} -c -o $@ $<

phase_cmd_objc_lib = CompileLib
quiet_cmd_objc_lib = $@
      cmd_objc_lib = ${OBJC} ${LIB_CFLAGS} ${OBJCFLAGS} ${CPPFLAGS} -c -o $@ $<

phase_cmd_objc_plugin = CompilePlugin
quiet_cmd_objc_plugin = $@
      cmd_objc_plugin = ${OBJC} ${PLUGIN_CFLAGS} ${OBJCFLAGS} ${CPPFLAGS} -c -o $@ $<

.m.o:
	$(call echo-cmd,cmd_objc)
	$(cmd_objc)

.m.lib.o:
	$(call echo-cmd,cmd_objc_lib)
	$(cmd_objc_lib)

.m.plugin.o:
	$(call echo-cmd,cmd_objc_plugin)
	$(cmd_objc_plugin)

phase_cmd_objcxx = CompileExe
quiet_cmd_objcxx = $@
      cmd_objcxx = ${OBJCXX} ${OBJCXXFLAGS} ${OBJCFLAGS} ${CPPFLAGS} -c -o $@ $<

phase_cmd_objcxx_lib = CompileLib
quiet_cmd_objcxx_lib = $@
      cmd_objcxx_lib = ${OBJCXX} ${LIB_CFLAGS} ${OBJCXXFLAGS} ${OBJCFLAGS} ${CPPFLAGS} -c -o $@ $<

phase_cmd_objcxx_plugin = CompilePlugin
quiet_cmd_objcxx_plugin = $@
      cmd_objcxx_plugin = ${OBJCXX} ${PLUGIN_CFLAGS} ${OBJCXXFLAGS} ${OBJCFLAGS} ${CPPFLAGS} -c -o $@ $<

.mm.o:
	$(call echo-cmd,cmd_objcxx)
	$(cmd_objcxx)

.mm.lib.o:
	$(call echo-cmd,cmd_objcxx_lib)
	$(cmd_objcxx_lib)

.mm.plugin.o:
	$(call echo-cmd,cmd_objcxx_plugin)
	$(cmd_objcxx_plugin)

phase_cmd_msgfmt = CompileResource
quiet_cmd_msgfmt = $@
      cmd_msgfmt = ${MSGFMT} -c -o $@ $<

.po.mo:
	$(call echo-cmd,cmd_msgfmt)
	$(cmd_msgfmt)

phase_cmd_pythonc = CompilePython
quiet_cmd_pythonc = $@
      cmd_pythonc = ${PYTHON} ${PYTHON_FLAGS} -c "import py_compile; py_compile.compile('$<')"

.py.pyc:
	$(call echo-cmd,cmd_pythonc)
	$(cmd_pythonc)

phase_cmd_windres = CompileResource
quiet_cmd_windres = $@
      cmd_windres = ${WINDRES} ${CPPFLAGS} -J rc -O coff -o $@ $<

.rc.o .rc.lib.o .rc.plugin.o:
	$(call echo-cmd,cmd_windres)
	$(cmd_windres)

phase_cmd_as = CompileExe
quiet_cmd_as = $@
      cmd_as = ${AS} ${ASFLAGS} ${CPPFLAGS} -c -o $@ $<

phase_cmd_as_lib = CompileLib
quiet_cmd_as_lib = $@
      cmd_as_lib = ${AS} ${LIB_CFLAGS} ${ASFLAGS} ${CPPFLAGS} -c -o $@ $<

phase_cmd_as_plugin = CompilePlugin
quiet_cmd_as_plugin = $@
      cmd_as_plugin = ${AS} ${PLUGIN_CFLAGS} ${ASFLAGS} ${CPPFLAGS} -c -o $@ $<

.S.o:
	$(call echo-cmd,cmd_as)
	$(cmd_as)

.S.lib.o:
	$(call echo-cmd,cmd_as_lib)
	$(cmd_as_lib)

.S.plugin.o:
	$(call echo-cmd,cmd_as_plugin)
	$(cmd_as_plugin)

phase_cmd_xpm = CompileExe
quiet_cmd_xpm = $@
      cmd_xpm = ${CC} ${CFLAGS} ${CPPFLAGS} -x c -c -o $@ $<

phase_cmd_xpm_lib = CompileLib
quiet_cmd_xpm_lib = $@
      cmd_xpm_lib = ${CC} ${LIB_CFLAGS} ${CFLAGS} ${CPPFLAGS} -x c -c -o $@ $<

phase_cmd_xpm_plugin = CompilePlugin
quiet_cmd_xpm_plugin = $@
      cmd_xpm_plugin = ${CC} ${PLUGIN_CFLAGS} ${CFLAGS} ${CPPFLAGS} -x c -c -o $@ $<

.xpm.o:
	$(call echo-cmd,cmd_xpm)
	$(cmd_xpm)

.xpm.lib.o:
	$(call echo-cmd,cmd_xpm_lib)
	$(cmd_xpm_lib)

.xpm.plugin.o:
	$(call echo-cmd,cmd_xpm_plugin)
	$(cmd_xpm_plugin)

install: ${SHARED_LIB} ${STATIC_LIB} ${STATIC_PIC_LIB} ${PLUGIN} ${PROG} install-extra
	for i in ${SUBDIRS}; do \
		${MAKE} -C $$i ${MFLAGS} install || exit $$?; \
	done

	for i in ${SHARED_LIB}; do \
		${INSTALL_STATUS}; \
		if ${MKDIR_P} ${DESTDIR}${libdir} ${INSTALL_LIB}; then \
			${INSTALL_OK}; \
		else \
			${INSTALL_FAILED}; \
		fi \
	done

	for i in ${STATIC_LIB} ${STATIC_PIC_LIB}; do \
		${INSTALL_STATUS}; \
		if ${MKDIR_P} ${DESTDIR}${libdir} && ${INSTALL} -m 644 $$i ${DESTDIR}${libdir}/$$i; then \
			${INSTALL_OK}; \
		else \
			${INSTALL_FAILED}; \
		fi \
	done

	for i in ${PLUGIN}; do \
		${INSTALL_STATUS}; \
		if ${MKDIR_P} ${DESTDIR}${plugindir} && ${INSTALL} -m 755 $$i ${DESTDIR}${plugindir}/$$i; then \
			${INSTALL_OK}; \
		else \
			${INSTALL_FAILED}; \
		fi \
	done

	for i in ${DATA}; do \
		${INSTALL_STATUS}; \
		if ${MKDIR_P} $$(dirname ${DESTDIR}${datadir}/${PACKAGE_NAME}/$$i) && ${INSTALL} -m 644 $$i ${DESTDIR}${datadir}/${PACKAGE_NAME}/$$i; then \
			${INSTALL_OK}; \
		else \
			${INSTALL_FAILED}; \
		fi \
	done

	for i in ${PROG}; do \
		${INSTALL_STATUS}; \
		if ${MKDIR_P} ${DESTDIR}${bindir} && ${INSTALL} -m 755 $$i ${DESTDIR}${bindir}/$$i; then \
			${INSTALL_OK}; \
		else \
			${INSTALL_FAILED}; \
		fi \
	done

	for i in ${INCLUDES}; do \
		${INSTALL_STATUS}; \
		if ${MKDIR_P} ${DESTDIR}${includedir}/${includesubdir} && ${INSTALL} -m 644 $$i ${DESTDIR}${includedir}/${includesubdir}/$$i; then \
			${INSTALL_OK}; \
		else \
			${INSTALL_FAILED}; \
		fi \
	done

	for i in ${MO_FILES}; do \
		${INSTALL_STATUS}; \
		if ${MKDIR_P} ${DESTDIR}${localedir}/$${i%.mo}/LC_MESSAGES && ${INSTALL} -m 644 $$i ${DESTDIR}${localedir}/$${i%.mo}/LC_MESSAGES/${localename}.mo; then \
			${INSTALL_OK}; \
		else \
			${INSTALL_FAILED}; \
		fi \
	done

	for i in ${MAN}; do \
		${INSTALL_STATUS}; \
		if ${MKDIR_P} ${DESTDIR}${mandir}/${mansubdir} && ${INSTALL} -m 644 $$i ${DESTDIR}${mandir}/${mansubdir}/$$i; then \
			${INSTALL_OK}; \
		else \
			${INSTALL_FAILED}; \
		fi \
	done

install-extra:

uninstall: uninstall-extra
	for i in ${SUBDIRS}; do \
		${MAKE} -C $$i ${MFLAGS} uninstall || exit $$?; \
	done

	for i in ${SHARED_LIB}; do \
		if test -f ${DESTDIR}${libdir}/$$i; then \
			if : ${UNINSTALL_LIB}; then \
				${DELETE_OK}; \
			else \
				${DELETE_FAILED}; \
			fi \
		fi; \
	done

	for i in ${STATIC_LIB} ${STATIC_PIC_LIB}; do \
		if test -f ${DESTDIR}${libdir}/$$i; then \
			if rm -f ${DESTDIR}${libdir}/$$i; then \
				${DELETE_OK}; \
			else \
				${DELETE_FAILED}; \
			fi \
		fi \
	done

	for i in ${PLUGIN}; do \
		if test -f ${DESTDIR}${plugindir}/$$i; then \
			if rm -f ${DESTDIR}${plugindir}/$$i; then \
				${DELETE_OK}; \
			else \
				${DELETE_FAILED}; \
			fi \
		fi \
	done
	-rmdir ${DESTDIR}${plugindir} >/dev/null 2>&1

	for i in ${DATA}; do \
		if test -f ${DESTDIR}${datadir}/${PACKAGE_NAME}/$$i; then \
			if rm -f ${DESTDIR}${datadir}/${PACKAGE_NAME}/$$i; then \
				${DELETE_OK}; \
			else \
				${DELETE_FAILED}; \
			fi \
		fi; \
		rmdir "$$(dirname ${DESTDIR}${datadir}/${PACKAGE_NAME}/$$i)" >/dev/null 2>&1 || true; \
	done
	-rmdir ${DESTDIR}${datadir}/${PACKAGE_NAME} >/dev/null 2>&1

	for i in ${PROG}; do \
		if test -f ${DESTDIR}${bindir}/$$i; then \
			if rm -f ${DESTDIR}${bindir}/$$i; then \
				${DELETE_OK}; \
			else \
				${DELETE_FAILED}; \
			fi \
		fi \
	done

	for i in ${INCLUDES}; do \
		if test -f ${DESTDIR}${includedir}/${includesubdir}/$$i; then \
			if rm -f ${DESTDIR}${includedir}/${includesubdir}/$$i; then \
				${DELETE_OK}; \
			else \
				${DELETE_FAILED}; \
			fi \
		fi \
	done
	-rmdir ${DESTDIR}${includedir}/${includesubdir} >/dev/null 2>&1

	for i in ${MO_FILES}; do \
		if test -f ${DESTDIR}${localedir}/$${i%.mo}/LC_MESSAGES/${localename}.mo; then \
			if rm -f ${DESTDIR}${localedir}/$${i%.mo}/LC_MESSAGES/${localename}.mo; then \
				${DELETE_OK}; \
			else \
				${DELETE_FAILED}; \
			fi \
		fi \
	done

	for i in ${MAN}; do \
		if test -f ${DESTDIR}${mandir}/${mansubdir}/$$i; then \
			if rm -f ${DESTDIR}${mandir}/${mansubdir}/$$i; then \
				${DELETE_OK}; \
			else \
				${DELETE_FAILED}; \
			fi \
		fi \
	done

uninstall-extra:

clean:
	for i in ${SUBDIRS}; do \
		${MAKE} -C $$i ${MFLAGS} clean || exit $$?; \
	done

	for i in ${DEPS} ${OBJS} ${OBJS_EXTRA} ${LIB_OBJS} ${LIB_OBJS_EXTRA} ${PLUGIN_OBJS} ${PROG} ${PROG_NOINST} ${SHARED_LIB} ${SHARED_LIB_NOINST} ${STATIC_LIB} ${STATIC_LIB_NOINST} ${STATIC_PIC_LIB} ${STATIC_PIC_LIB_NOINST} ${PLUGIN} ${PLUGIN_NOINST} ${CLEAN_LIB} ${MO_FILES} ${CLEAN}; do \
		if test -f $$i -o -d $$i; then \
			if rm -fr $$i; then \
				${DELETE_OK}; \
			else \
				${DELETE_FAILED}; \
			fi \
		fi \
	done

distclean: clean
	for i in ${SUBDIRS}; do \
		${MAKE} -C $$i ${MFLAGS} distclean || exit $$?; \
	done

	for i in ${DISTCLEAN} *.d *~; do \
		if test -f $$i -o -d $$i; then \
			if rm -fr $$i; then \
				${DELETE_OK}; \
			else \
				${DELETE_FAILED}; \
			fi \
		fi \
	done

ifndef V

QUIET = quiet_
LINK_STATUS = printf "Link: $@\n"
LINK_OK = true
LINK_FAILED = exit $$?
INSTALL_STATUS = printf "Install: $$i\n"
INSTALL_OK = true
INSTALL_FAILED = exit $$?
DELETE_OK = printf "Delete: $$i\n"
DELETE_FAILED = exit $$?

else

QUIET = 
LINK_STATUS = printf "Link: ${LD} $@ $$LDOBJS ${LDFLAGS} ${LIBS}\n"
LINK_OK = true
LINK_FAILED = exit $$?
INSTALL_STATUS = printf "Install: $$i\n"
INSTALL_OK = true
INSTALL_FAILED = exit $$?
DELETE_OK = printf "Delete: $$i\n"
DELETE_FAILED = exit $$?

endif

-include *.d
